### [LibreChat](https://github.com/danny-avila/LibreChat)

> Handle: `librechat`
> URL: [http://localhost:33891](http://localhost:33891)

<p align="center">
  <a href="https://librechat.ai">
    <img src="https://raw.githubusercontent.com/danny-avila/LibreChat/main/client/public/assets/logo.svg" height="256">
  </a>
</p>

<p align="center">
  <a href="https://discord.librechat.ai">
    <img
      src="https://img.shields.io/discord/1086345563026489514?label=&logo=discord&style=for-the-badge&logoWidth=20&logoColor=white&labelColor=000000&color=blueviolet">
  </a>
  <a href="https://www.youtube.com/@LibreChat">
    <img
      src="https://img.shields.io/badge/YOUTUBE-red.svg?style=for-the-badge&logo=youtube&logoColor=white&labelColor=000000&logoWidth=20">
  </a>
  <a href="https://docs.librechat.ai">
    <img
      src="https://img.shields.io/badge/DOCS-blue.svg?style=for-the-badge&logo=read-the-docs&logoColor=white&labelColor=000000&logoWidth=20">
  </a>
  <a aria-label="Sponsors" href="https://github.com/sponsors/danny-avila">
    <img
      src="https://img.shields.io/badge/SPONSORS-brightgreen.svg?style=for-the-badge&logo=github-sponsors&logoColor=white&labelColor=000000&logoWidth=20">
  </a>
</p>

Enhanced ChatGPT Clone: Features OpenAI, Assistants API, Azure, Groq, GPT-4 Vision, Mistral, Bing, Anthropic, OpenRouter, Vertex AI, Gemini, AI model switching, message search, langchain, DALL-E-3, ChatGPT Plugins, OpenAI Functions, Secure Multi-User System, Presets, completely open-source for self-hosting. More features in development.

#### Starting

```bash
# Will start librechat alongside
# the default webui
harbor up librechat
```

If you want to make LibreChat your default UI, please see the information below:
```bash
# Replace the default webui with librechat
# afterwards, you can just run `harbor up`
harbor defaults rm webui
harbor defaults add librechat

# You'll also want to set librechat as a main UI
harbor config set ui.main librechat

# That'll allow you to open the librechat
# directly with
harbor open
harbor qr
harbor tunnel
```

#### Configuration

LibreChat comes with a lot of features and settings that can be adjusted to your liking. Harbor will keep all the relevant files in the `librechat` folder of the workspace.

- [Official Configuration reference](https://www.librechat.ai/docs/configuration)
- [./librechat/librechat.yml](../blob/main/librechat/librechat.yml) - main configuration file
- [./librechat/.env](../blob/main/librechat/.env) - service-specific environment variables