### [Lobe Chat](https://github.com/lobehub/lobe-chat)

> Handle: `lobechat`
> URL: [http://localhost:34071](http://localhost:34071)

![Lobe Chat splash image](https://raw.githubusercontent.com/lobehub/lobe-chat/main/public/og/cover.png)

Lobe Chat - an open-source, modern-design AI chat framework. Supports Multi AI Providers( OpenAI / Claude 3 / Gemini / Ollama / Azure / DeepSeek), Knowledge Base (file upload / knowledge management / RAG )

#### Starting

```bash
# Will start lobechat alongside
# the default webui
harbor up lobechat
```

If you want to make LobeChat your default UI, please see the information below:
```bash
# Replace the default webui with lobechat
# afterwards, you can just run `harbor up`
harbor defaults rm webui
harbor defaults add lobechat
```

#### Configuration

LobeChat is automatically connected to `ollama` if it's running.

> [!NOTE]
> LobeChat only works with a **predefined** set of models, you can select one when UI is started.

Additional configuration can be done via `override.env` in the `lobechat` service folder.

```bash
# See the full path to the override.env file
echo $(harbor home)/lobechat/override.env

# Edit the file with your favorite editor
vscode $(harbor home)/lobechat/override.env
```
