### [Parler](https://github.com/huggingface/parler-tts)

> Handle: `parler`
> URL: [http://localhost:33971](http://localhost:33971)

![Parler logo](https://huggingface.co/datasets/parler-tts/images/resolve/main/thumbnail.png)

Parler-TTS is a lightweight text-to-speech (TTS) model that can generate high-quality, natural sounding speech in the style of a given speaker (gender, pitch, speaking style, etc).

#### Starting

```bash
# [Optional] pre-pull the images
# (otherwise will be pulled on start, ~4Gb due to PyTorch)
harbor pull parler

# [Optional] pre-download the parler model
# (otherwise will be downloaded on start)
harbor hf download $(h parler model)

# Start with Parler
harbor up parler

# Open WebUI pre-configured with Parler as voice backend
harbor open
```

#### Configuring

```bash
# Configure model and the voice

# See the current model
# parler-tts/parler-tts-mini-v1 by default
# you can also use older parler models
harbor parler model

# Set new model, for example Parler large
harbor parler model parler-tts/parler-tts-large-v1

# See the current voice prompt
harbor parler voice

# Set the new voice prompt
harbor parler voice "Gary speeks in calm and reassuring tone."

# You'll need to restart after reconfiguring either
harbor restart
```
