### [Perplexica](https://github.com/ItzCrazyKns/Perplexica)

> Handle: `perplexica`
> URL: [http://localhost:34041/](http://localhost:34041/)

![video-preview](https://raw.githubusercontent.com/ItzCrazyKns/Perplexica/master/.assets/perplexica-screenshot.png)

Perplexica is an AI-powered search engine. It is an Open source alternative to Perplexity AI

#### Starting

```bash
# [Optional] Pull the perplexica images
# ahead of starting the service
harbor pull perplexica

# Start the service, it makes
# little sense to run it without searxng
harbor up perplexica searxng

# [Optional] Open the service in browser
harbor open perplexica
```

#### Configuration

Harbor will pre-connect Perplexica to `searxng` and `ollama` services, if running together. You can also provide API keys for the LLM APIs supported by the Perplexica.

```bash
# [Optional] Set the API keys for supported backends

# OpenAI, via keys pool
harbor openai keys add <your key>
# OpenAI, via Harbor config as a main key
harbor config set openai.key <your key>

# Groq, via Harbor config
harbor config set groq.key <your key>

# Anthropic, via Harbor config
harbor config set anthropic.key <your key>
```

Apart from that, you may use `perplexica/override.env` in the Harbor workspace for additional local configuration overrides. Unfortunately, some of the settings (Embeddings config) can't be pre-configured so have to be done via the Perplexica UI.
