### [Qdrant](https://github.com/qdrant/qdrant)

> Handle: `qdrant`<br/>
> REST API: http://localhost:34221<br/>
> Web UI: http://localhost:34221/dashboard<br/>
> GRPC API: http://localhost:34222<br/>
> Integration author: [@ic4l4s9c](https://github.com/ic4l4s9c)

Qdrant (read: quadrant) is a vector similarity search engine and vector database. It provides a production-ready service with a convenient API to store, search, and manage points—vectors with an additional payload Qdrant is tailored to extended filtering support. It makes it useful for all sorts of neural-network or semantic-based matching, faceted search, and other applications.

#### Starting

```bash
# [Optional] Pre-pull the images
harbor pull qdrant

# Start the service
harbor up qdrant
```

#### Usage

The main use-case is to connect the `qdrant` service to other services that support it as a vector storage backend.

You can obtain the URL for accessing qdrant API in the following way:

```bash
# URL for access from the host
harbor url qdrant

# URL for access in the same LAN
harbor url -a qdrant

# [Optional] create tunnel for access via
# public interned
# ⚠️ Never expose unprotected endpoints to the public internet
harbor tunnel qdrant
```

You can get (and configure) the API keys for the service using `harbor config`:

```bash
# Get the current API keys
harbor config get qdrant.api_key
harbor config get qdrant.read_only_api_key

# Set the API keys
harbor config set qdrant.api_key <API_KEY>
harbor config set qdrant.read_only_api_key <API_KEY>
```

See the [official documentation](https://qdrant.tech/documentation/) for more details.