### [cloudflared](https://developers.cloudflare.com/cloudflare-one/connections/connect-networks/)

> Handle: `cfd`
> URL: -

Cloudflare Tunnel provides you with a secure way to connect your resources to Cloudflare without a publicly routable IP address.

> [!WARN]
> Exposing your computer resources to the internet can be dangerous. Bad things can happen. Be careful.

#### Starting

By default, Harbor will not start any tunnels.

```bash
# Launch your harbor as usual
harbor up

# Expose the the default UI
# to the internet
harbor tunnel

# Expose a specific service
harbor tunnel litellm

# Stop all currently established tunnels
harbor tunnel stop
```

#### Configuration

If you're confident you want a service to be exposed to the internet by default, Harbor can be configured to start a tunnel for it automatically.

```bash
# See current automatic tunnels
harbor tunnels

# Add a new tunnel as a default
harbor tunnels add webui

# When starting next time, Harbor
# will also spin up a tunnel for the webui
harbor up

# Remove a tunnel from the default list
harbor tunnels rm webui

# Clean tunnels list
harbor tunnels rm
```
